#include <stdio.h>
#include <gmp.h>
#include "factor.h"
#include "RSAbase.h"

#define RSA_public_e 0x10001
#define RSACreateGiveup 300


int RSAbase_generate(RSAKeybase_struct *key,mpz_srcptr p_seed,mpz_srcptr q_seed)
{
	mpz_t p,q,e;
	mpz_t q1,phi,test;
	int count;
	
	mpz_init(key->n);
	mpz_init(key->d);
	mpz_init_set_ui(e,RSA_public_e);
	mpz_init(p);
	mpz_init(q);
	mpz_init(q1);
	mpz_init(phi);
	mpz_init(test);
	
	mpz_set(q,q_seed);
	mpz_set(p,p_seed);
	for(count = 0;count < RSACreateGiveup;count++,mpz_add_ui(p,p,2),mpz_add_ui(q,q,2)){
		primize(q);
		mpz_sub_ui(q1,q,1);
		primize(p);
		mpz_sub_ui(phi,p,1);
		mpz_mul(phi,phi,q1);
		if(mpz_invert(key->d,e,phi) == 0){
			continue;
		}
		mpz_mul(key->n,p,q);
		mpz_set_ui(test,0x7743);
		mpz_powm(test,test,e,key->n);
		mpz_powm(test,test,key->d,key->n);
		if(mpz_cmp_ui(test,0x7743) == 0){
			break;
		}
	}
	
	mpz_clear(p);
	mpz_clear(q);
	mpz_clear(q1);
	mpz_clear(phi);
	mpz_clear(test);
	mpz_clear(e);
	if(count != RSACreateGiveup)
		return 0;
		
	mpz_clear(key->n);
	mpz_clear(key->d);
	return -1;
}

void RSAbase_clear(RSAKeybase_struct *key)
{
	mpz_clear(key->n);
	mpz_clear(key->d);
}

void RSAbase_encrypt(mpz_ptr m,RSAKeybase_struct *key)
{
	mpz_powm(m,m,key->d,key->n);
}

void RSAbase_decrypt(mpz_ptr m,mpz_srcptr n)
{
	mpz_powm_ui(m,m,RSA_public_e,n);
}
